Make the names of the rules for installing extra Squeeze debs line up
[OpenSRF.git] / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 # Author: Dan Scott <dscott@laurentian.ca>
4 #
5 # Makefile to install prerequisites for OpenSRF
6 #
7 # Currently supports Debian (lenny/squeeze), Ubuntu (hardy/lucid)
8 # Working towards support of CentOS 5 / RHEL 5 and Fedora.
9 # Installs Perl prereqs, libjs with Perl wrapper
10 #
11 # usage:
12 #       make -f Makefile.install debian-lenny
13 #       - or -
14 #       make -f Makefile.install debian-squeeze
15 #       - or -
16 #       make -f Makefile.install ubuntu-hardy
17 #       - or -
18 #       make -f Makefile.install ubuntu-lucid
19 #       - or -
20 #       make -f Makefile.install centos
21 #       - or -
22 #       make -f Makefile.install rhel
23 #       - or -
24 #       make -f Makefile.install fedora13
25 #
26 # Notes:
27 #
28 #       This makefile has been tested much more with Ubuntu and Debian than
29 #   CentOS, Fedora, or RHEL.
30 #
31 # ---------------------------------------------------------------------
32
33 # Make any assumptions about the shell being used explicit
34 SHELL=/bin/bash 
35
36 # XXX
37 # Gentoo needs explicit versions on many of these packages
38 # to simulate a "blessed" set of packages
39
40 # 64 or 32 bit os?
41 LBITS=$(shell getconf LONG_BIT)
42
43 # ejabberd is not packaged on CentOS/RHEL, so we have to
44 # download the installable package from the source
45 EJABBERD_VER=2.1.2
46 EJABBERD_PKG=ejabberd-2.1.2-linux-x86-installer.bin
47 EJABBERD_PKG_x64=ejabberd-2.1.2-linux-x86_64-installer.bin
48 EJABBERD_HOST=http://www.process-one.net/downloads/ejabberd
49
50 # Centos and Redhat will require the rpmforge repository mostly for memcache and perl modules
51 RPMFORGE_PKG_x64=rpmforge-release-0.5.1-1.el5.rf.x86_64.rpm
52 RPMFORGE_PKG=rpmforge-release-0.5.1-1.el5.rf.i386.rpm
53 RPMFORGE_HOST=http://packages.sw.be/rpmforge-release
54
55 # need newer libtool, autoconf, and automake on centos
56 AUTOCONF_HOST=http://ftp.gnu.org/gnu/autoconf
57 AUTOCONF_PKG=autoconf-2.65
58 LIBTOOL_HOST=http://ftp.gnu.org/gnu/libtool
59 LIBTOOL_PKG=libtool-2.2.6b
60 AUTOMAKE_HOST=http://ftp.gnu.org/gnu/automake
61 AUTOMAKE_PKG=automake-1.11
62
63 # libmemcached is only packaged on newer distros
64 LIBMEMCACHED=libmemcached-0.40
65 LIBMEMCACHED_HOST=http://download.tangent.org
66
67 # XML::LibXSLT fails due to old libxslt
68 XSLT=libxslt-1.1.22
69 XSLT_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxslt/1.1
70
71 # libxslt depends on a newer version of libxml2:
72 XML2=libxml2-2.6.30
73 XML2_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxml2/2.6
74
75 APT_TOOL=aptitude -yq
76
77 # Debian dependencies
78 DEBS =  \
79         apache2-mpm-prefork\
80         apache2-prefork-dev\
81         autoconf\
82         automake\
83         build-essential\
84         ejabberd\
85         less\
86         libapache2-mod-perl2\
87         libcache-memcached-perl\
88         libclass-dbi-abstractsearch-perl\
89         libclass-dbi-sqlite-perl\
90         libdatetime-format-builder-perl\
91         libdatetime-format-mail-perl\
92         libdatetime-perl\
93         libdatetime-timezone-perl\
94         liberror-perl\
95         libexpat1-dev\
96         libfile-find-rule-perl\
97         libfreezethaw-perl\
98         libgcrypt11-dev \
99         libgdbm-dev \
100         liblog-log4perl-perl\
101         libmodule-build-perl\
102         libnet-jabber-perl\
103         libperl-dev\
104         libreadline5-dev\
105         librpc-xml-perl\
106         libtemplate-perl\
107         libtest-pod-perl\
108         libtie-ixhash-perl\
109         libtool\
110         libuniversal-require-perl\
111         libunix-syslog-perl\
112         libwww-perl\
113         libxml2-dev\
114         libxml-libxml-perl\
115         libxml-libxslt-perl\
116         libxml-simple-perl\
117         libxslt1-dev\
118         memcached\
119         ntpdate\
120         pkg-config\
121         psmisc\
122         python-dev\
123         python-libxml2\
124         python-setuptools
125
126 CENTOS = \
127         apr-util-devel \
128         autoconf \
129         automake \
130         gcc \
131         gcc-c++ \
132         gdbm-devel \
133         httpd-devel \
134         less \
135         libmemcache-devel \
136         libtool \
137         libxml2-devel \
138         libxslt-devel \
139         make \
140         memcached \
141         mod_perl \
142         mod_ssl \
143         ncurses \
144         ncurses-devel \
145         ntp \
146         perl-Cache-Memcached \
147         perl-Class-DBI-AbstractSearch \
148         perl-Class-DBI-SQLite \
149         perl-DateTime \
150         perl-DateTime-Format-ISO8601 \
151         perl-DateTime-Format-Mail \
152         perl-DateTime-Set \
153         perl-DateTime-TimeZone \
154         perl-DBI \
155         perl-Email-Send \
156         perl-Error \
157         perl-File-Find-Rule \
158         perl-FreezeThaw \
159         perl-JSON-XS \
160         perl-libwww-perl \
161         perl-Log-Log4perl \
162         perl-Memcached-libmemcached \
163         perl-Module-Build \
164         perl-Net-Server \
165         perl-Template-Toolkit \
166         perl-Test-Pod \
167         perl-Tie-IxHash \
168         perl-UNIVERSAL-require \
169         perl-Unix-Syslog \
170         perl-XML-Parser \
171         psmisc \
172         python-devel \
173         python-setuptools\
174         readline-devel \
175         wget
176
177 CENTOS_PERL = \
178         Net::Jabber \
179         Net::XMPP \
180         RPC::XML \
181         XML::LibXML \
182         XML::LibXSLT \
183         XML::Simple
184
185 FEDORAS = \
186         autoconf \
187         automake \
188         ejabberd \
189         expat-devel \
190         gcc \
191         gdbm-devel \
192         httpd \
193         httpd-devel \
194         less \
195         libgcrypt-devel \
196         libmemcached \
197         libmemcached-devel \
198         libtool \
199         libxml2-devel \
200         libxml2-python \
201         libxslt-devel \
202         make \
203         memcached \
204         mod_perl \
205         ntpdate \
206         perl-Cache-Memcached \
207         perl-Class-DBI \
208         perl-Class-DBI-AbstractSearch \
209         perl-Class-DBI-SQLite \
210         perl-DateTime-Format-Builder \
211         perl-DateTime-Format-ISO8601 \
212         perl-DateTime-Format-Mail \
213         perl-DateTime-Set \
214         perl-devel \
215         perl-Error \
216         perl-File-Find-Rule \
217         perl-FreezeThaw \
218         perl-JSON-XS \
219         perl-libwww-perl \
220         perl-Log-Log4perl \
221         perl-Module-Build \
222         perl-Net-Jabber \
223         perl-Net-Server \
224         perl-RPC-XML \
225         perl-SQL-Abstract-Limit \
226         perl-Template-Toolkit \
227         perl-Test-Deep \
228         perl-Test-Exception \
229         perl-Test-Pod \
230         perl-Tie-IxHash \
231         perl-UNIVERSAL-require \
232         perl-Unix-Syslog \
233         perl-XML-LibXML \
234         perl-XML-LibXSLT \
235         perl-XML-Simple \
236         psmisc \
237         python-devel \
238         python-dns \
239         python-memcached \
240         python-setuptools \
241         python-simplejson \
242         readline-devel
243
244 DEB_APACHE_MODS = \
245         ssl
246
247 EXTRA_DEBS = \
248         libdatetime-format-iso8601-perl \
249         libjson-xs-perl \
250         libnet-server-perl
251
252 EXTRA_DEBS_SQUEEZE = \
253         libmemcached-dev \
254         libxml-libxml-perl \
255         libxml-libxslt-perl \
256         memcached-tools
257
258 EXTRA_DEBS_UBUNTU_LUCID = \
259         libmemcached-dev\
260         libxml-libxml-perl \
261         libxml-libxslt-perl
262
263 # generic CPAN modules:
264 #   * DateTime::Format::ISO8601 is packaged by both Debian Lenny and Ubuntu Intrepid
265 #   * JSON::XS is packaged by both Debian Lenny and Ubuntu Intrepid
266 #   * libnet-server-perl 0.97 is packaged on Debian Lenny and Ubuntu Intrepid
267 #     - is there a specific need for 0.90?
268 CPAN_MODULES = \
269         DateTime::Format::ISO8601 \
270         RHANDOM/Net-Server-0.90.tar.gz \
271         JSON::XS
272
273 #   libxml-libxml-perl on Debian Lenny and Ubuntu Intrepid is 1.66, which
274 #   has broken namespace handling. so we still need to install these from
275 #   CPAN. *sigh*
276 CPAN_MODULES_XML = \
277         XML::LibXML \
278         XML::LibXSLT
279
280 # ----------------------------------------------------------------------------
281
282 all: 
283         @echo "please specify an OS" && exit 0
284
285
286 centos: install_rpmforge install_centos_rpms install_ejabberd install_buildutils install_libmemcached install_libxml2 install_libxslt install_centos_perl create_ld_local
287
288 debian-lenny: generic_debian install_cpan_xml lenny install_libmemcached
289 debian-squeeze: generic_debian squeeze
290 lenny: install_extra_debs
291 squeeze: install_extra_debs_squeeze
292 generic_debian: install_debs debian_sys_config
293
294 fedora13: install_fedora_rpms
295
296 rhel: centos
297
298 ubuntu-hardy: generic_ubuntu install_cpan_xml hardy
299 ubuntu-lucid: generic_ubuntu lucid
300 hardy: install_cpan install_libmemcached 
301 lucid: install_extra_debs install_extra_debs_lucid
302 generic_ubuntu: install_debs debian_sys_config
303
304 # - COMMON TARGETS ---------------------------------------------------------
305
306 # Install the CPAN modules
307 install_cpan: 
308         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
309
310 # Install CPAN modules that need to be forced
311 install_cpan_force: 
312         for m in $(CPAN_MODULES_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
313
314 # Install the CPAN XML modules
315 install_cpan_xml: 
316         for m in $(CPAN_MODULES_XML); do perl -MCPAN -e "install \"$$m\";"; done
317
318 # Install ejabberd from official project installer binary
319 install_ejabberd:
320         if [ $(LBITS) -eq 64 ]; then \
321                 if [ ! -f $(EJABBERD_PKG_x64).gz ]; then \
322                         wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG_x64).gz; \
323                 fi; \
324                 gunzip $(EJABBERD_PKG_x64).gz; \
325                 chmod u+x $(EJABBERD_PKG_x64); \
326                 ./$(EJABBERD_PKG_x64) --mode unattended --prefix /opt/ejabberd --adminpw opensrf ; \
327         fi;
328         if [ $(LBITS) -eq 32 ]; then \
329                 if [ ! -f $(EJABBERD_PKG).gz ]; then \
330                         wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG).gz; \
331                 fi; \
332                 gunzip $(EJABBERD_PKG).gz; \
333                 chmod u+x $(EJABBERD_PKG); \
334                 ./$(EJABBERD_PKG) --mode unattended --prefix /opt/ejabberd --adminpw opensrf ; \
335         fi;
336
337 # Install rpmforge for redhat and centos
338 install_rpmforge:
339         if [ $(LBITS) -eq 64 ]; then \
340                 if [ ! -f $(RPMFORGE_PKG_x64) ]; then \
341                         wget $(RPMFORGE_HOST)/$(RPMFORGE_PKG_x64) ; \
342                         yum -y remove subversion*i386 ; \
343                 fi; \
344                 rpm -Uvh --force ./$(RPMFORGE_PKG_x64) ; \
345         fi;
346         if [ $(LBITS) -eq 32 ]; then \
347                 if [ ! -f $(RPMFORGE_PKG) ]; then \
348                         wget $(RPMFORGE_HOST)/$(RPMFORGE_PKG) ; \
349                 fi; \
350                 rpm -Uvh --force ./$(RPMFORGE_PKG) ; \
351         fi;
352         yum update -y
353
354 # Install automake, autoconf, and libtool
355 install_buildutils:
356         if [ ! -f $(LIBTOOL_PKG).tar.gz ]; then wget $(LIBTOOL_HOST)/$(LIBTOOL_PKG).tar.gz; fi;
357         tar zxf $(LIBTOOL_PKG).tar.gz
358         cd $(LIBTOOL_PKG) && ./configure --prefix=/usr && make && make install
359
360         if [ ! -f $(AUTOCONF_PKG).tar.gz ]; then wget $(AUTOCONF_HOST)/$(AUTOCONF_PKG).tar.gz; fi;
361         tar zxf $(AUTOCONF_PKG).tar.gz
362         cd $(AUTOCONF_PKG) && ./configure --prefix=/usr && make && make install
363         
364         if [ ! -f $(AUTOMAKE_PKG).tar.gz ]; then wget $(AUTOMAKE_HOST)/$(AUTOMAKE_PKG).tar.gz; fi;
365         tar zxf $(AUTOMAKE_PKG).tar.gz
366         cd $(AUTOMAKE_PKG) && ./configure --prefix=/usr && make && make install
367
368 # Install libmemcached from the official project source
369 install_libmemcached:
370         if [ ! -d $(LIBMEMCACHED).tar.gz ]; then wget $(LIBMEMCACHED_HOST)/$(LIBMEMCACHED).tar.gz; fi;
371         tar xzf $(LIBMEMCACHED).tar.gz
372         cd $(LIBMEMCACHED) && ./configure && make && make install
373
374 # Install a newer version of libxslt
375 install_libxslt:    
376         if [ ! -d $(XSLT) ]; then wget $(XSLT_HOST)/$(XSLT).tar.gz; fi;
377         tar xzf $(XSLT).tar.gz
378         cd $(XSLT) && ./configure --with-libxml-prefix=/usr/local && make && make install
379
380 # Install a newer version of libxml2
381 install_libxml2:    
382         if [ ! -d $(XML2) ]; then wget $(XML2_HOST)/$(XML2).tar.gz; fi;
383         tar xzf $(XML2).tar.gz
384         cd $(XML2) && ./configure && make && make install
385
386 clean:
387         make -C $(LIBJS_PERL) clean
388         make -C $(XML2) clean
389         make -C $(XSLT) clean
390         make -f Makefile.ref -C js/src/ clean
391
392
393 # ------------------------------------------------------------------
394 # - DEBIAN ---------------------------------------------------------
395
396 debian_sys_config: 
397         # link the apache modules in
398         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
399
400         # adds a placeholder module so apxs will be happy
401         if [ ! "$$(grep mod_placeholder /etc/apache2/httpd.conf)" ]; then \
402                 echo -e "#\n#LoadModule mod_placeholder /usr/lib/apache2/modules/mod_placeholder.so" \
403                         >> /etc/apache2/httpd.conf; \
404         fi;
405
406 # Install the debian-specific dependencies
407 install_debs:
408         $(APT_TOOL) install $(DEBS)
409
410 # Install the debian-specific dependencies for more modern distros
411 install_extra_debs:
412         $(APT_TOOL) install $(EXTRA_DEBS)
413
414 install_extra_debs_squeeze:
415         $(APT_TOOL) install $(EXTRA_DEBS_SQUEEZE)
416
417 # Install even more packaged dependencies on modern distros
418 install_extra_debs_lucid:
419         $(APT_TOOL) install $(EXTRA_DEBS_UBUNTU_LUCID)
420
421 # Fedora
422 install_fedora_rpms:
423         yum -y install $(FEDORAS)
424
425 # CENTOS
426 install_centos_rpms:
427         yum -y install $(CENTOS)
428         yum -y update
429
430 install_centos_perl:
431         for m in $(CENTOS_PERL_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
432         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
433         for m in $(CENTOS_PERL_VERSION); do perl -MCPAN -e "CPAN::Shell->install \"$$m\";"; done
434         for m in $(CENTOS_PERL_NOTEST); do perl -MCPAN -e "CPAN::Shell->notest('install', \"$$m\";"; done
435         for m in $(CENTOS_PERL_LOCAL); do LD_LIBRARY_PATH=/usr/local/lib:/usr/lib:/lib perl -MCPAN -e "install \"$$m\";"; done
436
437 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
438 # if it is not already there
439 create_ld_local:
440         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
441                 echo '/usr/local/lib' > /etc/ld.so.conf.d/local.conf; \
442                 ldconfig; \
443         fi;
444
445 # vim:noet:sw=4:ts=4: